#include "AGS02MA.h"
#include "iic.h"


extern  float VOCdata;


u8 AGS02MA_Read_Status(ComTypeDef IIC_COM)
{
	u8 status;
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x35,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	status=IIC_RD_Byte(IIC_COM);
	Send_NOT_ACK(IIC_COM);
	IIC_Stop(IIC_COM);
	if((status&0x01)==0)//Ѹ
	{
	return 0;//Ѹ
	}else
	{
	return 1;//δ»æ״̬
	};
}







float AGS02MA_Read_Data(ComTypeDef IIC_COM)
{
	u8 Byte[5];
	u8 cnt=0;
	u32 VOC_temp=0;
	
	VOCdata=0;
	
	Init_IIC_Sensor_Port(IIC_COM);
	
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x34,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x00,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_Stop(IIC_COM);
	HAL_Delay(80);
	
	
	while((AGS02MA_Read_Status(IIC_COM)==1)&&cnt<100)
	{
		HAL_Delay(10);
		cnt++;
	}
	
	
	
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x35,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	Byte[0]=IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	Byte[1]=IIC_RD_Byte(IIC_COM);	
	Send_ACK(IIC_COM);
	Byte[2]=IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	Byte[3]=IIC_RD_Byte(IIC_COM);	
	Send_ACK(IIC_COM);
	Byte[4]=IIC_RD_Byte(IIC_COM);
	Send_NOT_ACK(IIC_COM);
	IIC_Stop(IIC_COM);

	if(Calc_CRC8(Byte,4)!=Byte[4])
		return 2;//CRCУ
	
	
	VOC_temp=(VOC_temp|Byte[1])<<8;
	VOC_temp=(VOC_temp|Byte[2])<<8;
	VOC_temp=(VOC_temp|Byte[3]);
	
	VOCdata=VOC_temp*1.0/1000;
	
	return 0;
	
}







